> For the complete documentation index, see [llms.txt](https://docs.xaman.dev/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.xaman.dev/concepts/implementation-checklist/protocol-specific-checks.md).

# Protocol specific checks

The XRP Ledger Protocol has several protocol-related things to check in your app/implementation to make the experience for end users better. Please take these things into account:

* [ ] Partial Payments: if you are processing received payments: **make sure to check the `delivered_amount` (meta) field** for the transaction outcome, and not the `Amount` field. Amount is the instruction, Delivered Amount is the actual delivered amount, which may be lower.\
  \
  See: <https://xrpl.org/partial-payments.html>
* [ ] When determining if users are able to send funds, make sure to take the Account and Owner reserve into account. See: <https://xrpl.org/reserves.html>\
  You can obtain them with a `server_info` and `account_info` call on the chain (tip: use <https://www.npmjs.com/package/xrpl-client> to interact with the network). Then calculate like this:\\

  ```ini
  ownerwnerCount = accountInfo.account_data.OwnerCount
  reserveBase = serverInfo.info.validated_ledger.reserve_base_native || serverInfo.info.validated_ledger.reserve_base_xrp
  reserveInc = serverInfo.info.validated_ledger.reserve_inc_native || serverInfo.info.validated_ledger.reserve_inc_xrp
  ```
* [ ] Use **WebSockets** over HTTP RPC (JSON POST) if you want realtime status updates from the ledger using the `subscribe` method. You can subsribe to ledger closes, transaction stream and account activity: <https://xrpl.org/subscribe.html>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.xaman.dev/concepts/implementation-checklist/protocol-specific-checks.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
